Merge branch 'ab/detox-gettext-tests'
[git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29         FAKE_EDITOR="$1"
30         export FAKE_EDITOR
31         EDITOR='"$FAKE_EDITOR"'
32         export EDITOR
33 }
34
35 test_set_index_version () {
36     GIT_INDEX_VERSION="$1"
37     export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41         awk '
42                 function name(n) {
43                         if (n == 0) return "RESET";
44                         if (n == 1) return "BOLD";
45                         if (n == 2) return "FAINT";
46                         if (n == 3) return "ITALIC";
47                         if (n == 7) return "REVERSE";
48                         if (n == 30) return "BLACK";
49                         if (n == 31) return "RED";
50                         if (n == 32) return "GREEN";
51                         if (n == 33) return "YELLOW";
52                         if (n == 34) return "BLUE";
53                         if (n == 35) return "MAGENTA";
54                         if (n == 36) return "CYAN";
55                         if (n == 37) return "WHITE";
56                         if (n == 40) return "BLACK";
57                         if (n == 41) return "BRED";
58                         if (n == 42) return "BGREEN";
59                         if (n == 43) return "BYELLOW";
60                         if (n == 44) return "BBLUE";
61                         if (n == 45) return "BMAGENTA";
62                         if (n == 46) return "BCYAN";
63                         if (n == 47) return "BWHITE";
64                 }
65                 {
66                         while (match($0, /\033\[[0-9;]*m/) != 0) {
67                                 printf "%s<", substr($0, 1, RSTART-1);
68                                 codes = substr($0, RSTART+2, RLENGTH-3);
69                                 if (length(codes) == 0)
70                                         printf "%s", name(0)
71                                 else {
72                                         n = split(codes, ary, ";");
73                                         sep = "";
74                                         for (i = 1; i <= n; i++) {
75                                                 printf "%s%s", sep, name(ary[i]);
76                                                 sep = ";"
77                                         }
78                                 }
79                                 printf ">";
80                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81                         }
82                         print
83                 }
84         '
85 }
86
87 lf_to_nul () {
88         perl -pe 'y/\012/\000/'
89 }
90
91 nul_to_q () {
92         perl -pe 'y/\000/Q/'
93 }
94
95 q_to_nul () {
96         perl -pe 'y/Q/\000/'
97 }
98
99 q_to_cr () {
100         tr Q '\015'
101 }
102
103 q_to_tab () {
104         tr Q '\011'
105 }
106
107 qz_to_tab_space () {
108         tr QZ '\011\040'
109 }
110
111 append_cr () {
112         sed -e 's/$/Q/' | tr Q '\015'
113 }
114
115 remove_cr () {
116         tr '\015' Q | sed -e 's/Q$//'
117 }
118
119 # Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
120 # If $1 is 'infinity', output forever or until the receiving pipe stops reading,
121 # whichever comes first.
122 generate_zero_bytes () {
123         test-tool genzeros "$@"
124 }
125
126 # In some bourne shell implementations, the "unset" builtin returns
127 # nonzero status when a variable to be unset was not set in the first
128 # place.
129 #
130 # Use sane_unset when that should not be considered an error.
131
132 sane_unset () {
133         unset "$@"
134         return 0
135 }
136
137 test_tick () {
138         if test -z "${test_tick+set}"
139         then
140                 test_tick=1112911993
141         else
142                 test_tick=$(($test_tick + 60))
143         fi
144         GIT_COMMITTER_DATE="$test_tick -0700"
145         GIT_AUTHOR_DATE="$test_tick -0700"
146         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
147 }
148
149 # Stop execution and start a shell. This is useful for debugging tests.
150 #
151 # Be sure to remove all invocations of this command before submitting.
152
153 test_pause () {
154         "$SHELL_PATH" <&6 >&5 2>&7
155 }
156
157 # Wrap git with a debugger. Adding this to a command can make it easier
158 # to understand what is going on in a failing test.
159 #
160 # Examples:
161 #     debug git checkout master
162 #     debug --debugger=nemiver git $ARGS
163 #     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
164 debug () {
165         case "$1" in
166         -d)
167                 GIT_DEBUGGER="$2" &&
168                 shift 2
169                 ;;
170         --debugger=*)
171                 GIT_DEBUGGER="${1#*=}" &&
172                 shift 1
173                 ;;
174         *)
175                 GIT_DEBUGGER=1
176                 ;;
177         esac &&
178         GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
179 }
180
181 # Usage: test_commit [options] <message> [<file> [<contents> [<tag>]]]
182 #   -C <dir>:
183 #       Run all git commands in directory <dir>
184 #   --notick
185 #       Do not call test_tick before making a commit
186 #   --append
187 #       Use "echo >>" instead of "echo >" when writing "<contents>" to
188 #       "<file>"
189 #   --signoff
190 #       Invoke "git commit" with --signoff
191 #   --author <author>
192 #       Invoke "git commit" with --author <author>
193 #
194 # This will commit a file with the given contents and the given commit
195 # message, and tag the resulting commit with the given tag name.
196 #
197 # <file>, <contents>, and <tag> all default to <message>.
198
199 test_commit () {
200         notick= &&
201         append= &&
202         author= &&
203         signoff= &&
204         indir= &&
205         while test $# != 0
206         do
207                 case "$1" in
208                 --notick)
209                         notick=yes
210                         ;;
211                 --append)
212                         append=yes
213                         ;;
214                 --author)
215                         author="$2"
216                         shift
217                         ;;
218                 --signoff)
219                         signoff="$1"
220                         ;;
221                 -C)
222                         indir="$2"
223                         shift
224                         ;;
225                 *)
226                         break
227                         ;;
228                 esac
229                 shift
230         done &&
231         indir=${indir:+"$indir"/} &&
232         file=${2:-"$1.t"} &&
233         if test -n "$append"
234         then
235                 echo "${3-$1}" >>"$indir$file"
236         else
237                 echo "${3-$1}" >"$indir$file"
238         fi &&
239         git ${indir:+ -C "$indir"} add "$file" &&
240         if test -z "$notick"
241         then
242                 test_tick
243         fi &&
244         git ${indir:+ -C "$indir"} commit \
245             ${author:+ --author "$author"} \
246             $signoff -m "$1" &&
247         git ${indir:+ -C "$indir"} tag "${4:-$1}"
248 }
249
250 # Call test_merge with the arguments "<message> <commit>", where <commit>
251 # can be a tag pointing to the commit-to-merge.
252
253 test_merge () {
254         label="$1" &&
255         shift &&
256         test_tick &&
257         git merge -m "$label" "$@" &&
258         git tag "$label"
259 }
260
261 # Efficiently create <nr> commits, each with a unique number (from 1 to <nr>
262 # by default) in the commit message.
263 #
264 # Usage: test_commit_bulk [options] <nr>
265 #   -C <dir>:
266 #       Run all git commands in directory <dir>
267 #   --ref=<n>:
268 #       ref on which to create commits (default: HEAD)
269 #   --start=<n>:
270 #       number commit messages from <n> (default: 1)
271 #   --message=<msg>:
272 #       use <msg> as the commit mesasge (default: "commit %s")
273 #   --filename=<fn>:
274 #       modify <fn> in each commit (default: %s.t)
275 #   --contents=<string>:
276 #       place <string> in each file (default: "content %s")
277 #   --id=<string>:
278 #       shorthand to use <string> and %s in message, filename, and contents
279 #
280 # The message, filename, and contents strings are evaluated by printf, with the
281 # first "%s" replaced by the current commit number. So you can do:
282 #
283 #   test_commit_bulk --filename=file --contents="modification %s"
284 #
285 # to have every commit touch the same file, but with unique content.
286 #
287 test_commit_bulk () {
288         tmpfile=.bulk-commit.input
289         indir=.
290         ref=HEAD
291         n=1
292         message='commit %s'
293         filename='%s.t'
294         contents='content %s'
295         while test $# -gt 0
296         do
297                 case "$1" in
298                 -C)
299                         indir=$2
300                         shift
301                         ;;
302                 --ref=*)
303                         ref=${1#--*=}
304                         ;;
305                 --start=*)
306                         n=${1#--*=}
307                         ;;
308                 --message=*)
309                         message=${1#--*=}
310                         ;;
311                 --filename=*)
312                         filename=${1#--*=}
313                         ;;
314                 --contents=*)
315                         contents=${1#--*=}
316                         ;;
317                 --id=*)
318                         message="${1#--*=} %s"
319                         filename="${1#--*=}-%s.t"
320                         contents="${1#--*=} %s"
321                         ;;
322                 -*)
323                         BUG "invalid test_commit_bulk option: $1"
324                         ;;
325                 *)
326                         break
327                         ;;
328                 esac
329                 shift
330         done
331         total=$1
332
333         add_from=
334         if git -C "$indir" rev-parse --quiet --verify "$ref"
335         then
336                 add_from=t
337         fi
338
339         while test "$total" -gt 0
340         do
341                 test_tick &&
342                 echo "commit $ref"
343                 printf 'author %s <%s> %s\n' \
344                         "$GIT_AUTHOR_NAME" \
345                         "$GIT_AUTHOR_EMAIL" \
346                         "$GIT_AUTHOR_DATE"
347                 printf 'committer %s <%s> %s\n' \
348                         "$GIT_COMMITTER_NAME" \
349                         "$GIT_COMMITTER_EMAIL" \
350                         "$GIT_COMMITTER_DATE"
351                 echo "data <<EOF"
352                 printf "$message\n" $n
353                 echo "EOF"
354                 if test -n "$add_from"
355                 then
356                         echo "from $ref^0"
357                         add_from=
358                 fi
359                 printf "M 644 inline $filename\n" $n
360                 echo "data <<EOF"
361                 printf "$contents\n" $n
362                 echo "EOF"
363                 echo
364                 n=$((n + 1))
365                 total=$((total - 1))
366         done >"$tmpfile"
367
368         git -C "$indir" \
369             -c fastimport.unpacklimit=0 \
370             fast-import <"$tmpfile" || return 1
371
372         # This will be left in place on failure, which may aid debugging.
373         rm -f "$tmpfile"
374
375         # If we updated HEAD, then be nice and update the index and working
376         # tree, too.
377         if test "$ref" = "HEAD"
378         then
379                 git -C "$indir" checkout -f HEAD || return 1
380         fi
381
382 }
383
384 # This function helps systems where core.filemode=false is set.
385 # Use it instead of plain 'chmod +x' to set or unset the executable bit
386 # of a file in the working directory and add it to the index.
387
388 test_chmod () {
389         chmod "$@" &&
390         git update-index --add "--chmod=$@"
391 }
392
393 # Get the modebits from a file or directory, ignoring the setgid bit (g+s).
394 # This bit is inherited by subdirectories at their creation. So we remove it
395 # from the returning string to prevent callers from having to worry about the
396 # state of the bit in the test directory.
397 #
398 test_modebits () {
399         ls -ld "$1" | sed -e 's|^\(..........\).*|\1|' \
400                           -e 's|^\(......\)S|\1-|' -e 's|^\(......\)s|\1x|'
401 }
402
403 # Unset a configuration variable, but don't fail if it doesn't exist.
404 test_unconfig () {
405         config_dir=
406         if test "$1" = -C
407         then
408                 shift
409                 config_dir=$1
410                 shift
411         fi
412         git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
413         config_status=$?
414         case "$config_status" in
415         5) # ok, nothing to unset
416                 config_status=0
417                 ;;
418         esac
419         return $config_status
420 }
421
422 # Set git config, automatically unsetting it after the test is over.
423 test_config () {
424         config_dir=
425         if test "$1" = -C
426         then
427                 shift
428                 config_dir=$1
429                 shift
430         fi
431         test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
432         git ${config_dir:+-C "$config_dir"} config "$@"
433 }
434
435 test_config_global () {
436         test_when_finished "test_unconfig --global '$1'" &&
437         git config --global "$@"
438 }
439
440 write_script () {
441         {
442                 echo "#!${2-"$SHELL_PATH"}" &&
443                 cat
444         } >"$1" &&
445         chmod +x "$1"
446 }
447
448 # Use test_set_prereq to tell that a particular prerequisite is available.
449 # The prerequisite can later be checked for in two ways:
450 #
451 # - Explicitly using test_have_prereq.
452 #
453 # - Implicitly by specifying the prerequisite tag in the calls to
454 #   test_expect_{success,failure} and test_external{,_without_stderr}.
455 #
456 # The single parameter is the prerequisite tag (a simple word, in all
457 # capital letters by convention).
458
459 test_unset_prereq () {
460         ! test_have_prereq "$1" ||
461         satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
462 }
463
464 test_set_prereq () {
465         if test -n "$GIT_TEST_FAIL_PREREQS_INTERNAL"
466         then
467                 case "$1" in
468                 # The "!" case is handled below with
469                 # test_unset_prereq()
470                 !*)
471                         ;;
472                 # (Temporary?) whitelist of things we can't easily
473                 # pretend not to support
474                 SYMLINKS)
475                         ;;
476                 # Inspecting whether GIT_TEST_FAIL_PREREQS is on
477                 # should be unaffected.
478                 FAIL_PREREQS)
479                         ;;
480                 *)
481                         return
482                 esac
483         fi
484
485         case "$1" in
486         !*)
487                 test_unset_prereq "${1#!}"
488                 ;;
489         *)
490                 satisfied_prereq="$satisfied_prereq$1 "
491                 ;;
492         esac
493 }
494 satisfied_prereq=" "
495 lazily_testable_prereq= lazily_tested_prereq=
496
497 # Usage: test_lazy_prereq PREREQ 'script'
498 test_lazy_prereq () {
499         lazily_testable_prereq="$lazily_testable_prereq$1 "
500         eval test_prereq_lazily_$1=\$2
501 }
502
503 test_run_lazy_prereq_ () {
504         script='
505 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&
506 (
507         cd "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&'"$2"'
508 )'
509         say >&3 "checking prerequisite: $1"
510         say >&3 "$script"
511         test_eval_ "$script"
512         eval_ret=$?
513         rm -rf "$TRASH_DIRECTORY/prereq-test-dir-$1"
514         if test "$eval_ret" = 0; then
515                 say >&3 "prerequisite $1 ok"
516         else
517                 say >&3 "prerequisite $1 not satisfied"
518         fi
519         return $eval_ret
520 }
521
522 test_have_prereq () {
523         # prerequisites can be concatenated with ','
524         save_IFS=$IFS
525         IFS=,
526         set -- $*
527         IFS=$save_IFS
528
529         total_prereq=0
530         ok_prereq=0
531         missing_prereq=
532
533         for prerequisite
534         do
535                 case "$prerequisite" in
536                 !*)
537                         negative_prereq=t
538                         prerequisite=${prerequisite#!}
539                         ;;
540                 *)
541                         negative_prereq=
542                 esac
543
544                 case " $lazily_tested_prereq " in
545                 *" $prerequisite "*)
546                         ;;
547                 *)
548                         case " $lazily_testable_prereq " in
549                         *" $prerequisite "*)
550                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
551                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
552                                 then
553                                         test_set_prereq $prerequisite
554                                 fi
555                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
556                         esac
557                         ;;
558                 esac
559
560                 total_prereq=$(($total_prereq + 1))
561                 case "$satisfied_prereq" in
562                 *" $prerequisite "*)
563                         satisfied_this_prereq=t
564                         ;;
565                 *)
566                         satisfied_this_prereq=
567                 esac
568
569                 case "$satisfied_this_prereq,$negative_prereq" in
570                 t,|,t)
571                         ok_prereq=$(($ok_prereq + 1))
572                         ;;
573                 *)
574                         # Keep a list of missing prerequisites; restore
575                         # the negative marker if necessary.
576                         prerequisite=${negative_prereq:+!}$prerequisite
577                         if test -z "$missing_prereq"
578                         then
579                                 missing_prereq=$prerequisite
580                         else
581                                 missing_prereq="$prerequisite,$missing_prereq"
582                         fi
583                 esac
584         done
585
586         test $total_prereq = $ok_prereq
587 }
588
589 test_declared_prereq () {
590         case ",$test_prereq," in
591         *,$1,*)
592                 return 0
593                 ;;
594         esac
595         return 1
596 }
597
598 test_verify_prereq () {
599         test -z "$test_prereq" ||
600         expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
601         BUG "'$test_prereq' does not look like a prereq"
602 }
603
604 test_expect_failure () {
605         test_start_
606         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
607         test "$#" = 2 ||
608         BUG "not 2 or 3 parameters to test-expect-failure"
609         test_verify_prereq
610         export test_prereq
611         if ! test_skip "$@"
612         then
613                 say >&3 "checking known breakage of $TEST_NUMBER.$test_count '$1': $2"
614                 if test_run_ "$2" expecting_failure
615                 then
616                         test_known_broken_ok_ "$1"
617                 else
618                         test_known_broken_failure_ "$1"
619                 fi
620         fi
621         test_finish_
622 }
623
624 test_expect_success () {
625         test_start_
626         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
627         test "$#" = 2 ||
628         BUG "not 2 or 3 parameters to test-expect-success"
629         test_verify_prereq
630         export test_prereq
631         if ! test_skip "$@"
632         then
633                 say >&3 "expecting success of $TEST_NUMBER.$test_count '$1': $2"
634                 if test_run_ "$2"
635                 then
636                         test_ok_ "$1"
637                 else
638                         test_failure_ "$@"
639                 fi
640         fi
641         test_finish_
642 }
643
644 # test_external runs external test scripts that provide continuous
645 # test output about their progress, and succeeds/fails on
646 # zero/non-zero exit code.  It outputs the test output on stdout even
647 # in non-verbose mode, and announces the external script with "# run
648 # <n>: ..." before running it.  When providing relative paths, keep in
649 # mind that all scripts run in "trash directory".
650 # Usage: test_external description command arguments...
651 # Example: test_external 'Perl API' perl ../path/to/test.pl
652 test_external () {
653         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
654         test "$#" = 3 ||
655         BUG "not 3 or 4 parameters to test_external"
656         descr="$1"
657         shift
658         test_verify_prereq
659         export test_prereq
660         if ! test_skip "$descr" "$@"
661         then
662                 # Announce the script to reduce confusion about the
663                 # test output that follows.
664                 say_color "" "# run $test_count: $descr ($*)"
665                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
666                 # to be able to use them in script
667                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
668                 # Run command; redirect its stderr to &4 as in
669                 # test_run_, but keep its stdout on our stdout even in
670                 # non-verbose mode.
671                 "$@" 2>&4
672                 if test "$?" = 0
673                 then
674                         if test $test_external_has_tap -eq 0; then
675                                 test_ok_ "$descr"
676                         else
677                                 say_color "" "# test_external test $descr was ok"
678                                 test_success=$(($test_success + 1))
679                         fi
680                 else
681                         if test $test_external_has_tap -eq 0; then
682                                 test_failure_ "$descr" "$@"
683                         else
684                                 say_color error "# test_external test $descr failed: $@"
685                                 test_failure=$(($test_failure + 1))
686                         fi
687                 fi
688         fi
689 }
690
691 # Like test_external, but in addition tests that the command generated
692 # no output on stderr.
693 test_external_without_stderr () {
694         # The temporary file has no (and must have no) security
695         # implications.
696         tmp=${TMPDIR:-/tmp}
697         stderr="$tmp/git-external-stderr.$$.tmp"
698         test_external "$@" 4> "$stderr"
699         test -f "$stderr" || error "Internal error: $stderr disappeared."
700         descr="no stderr: $1"
701         shift
702         say >&3 "# expecting no stderr from previous command"
703         if test ! -s "$stderr"
704         then
705                 rm "$stderr"
706
707                 if test $test_external_has_tap -eq 0; then
708                         test_ok_ "$descr"
709                 else
710                         say_color "" "# test_external_without_stderr test $descr was ok"
711                         test_success=$(($test_success + 1))
712                 fi
713         else
714                 if test "$verbose" = t
715                 then
716                         output=$(echo; echo "# Stderr is:"; cat "$stderr")
717                 else
718                         output=
719                 fi
720                 # rm first in case test_failure exits.
721                 rm "$stderr"
722                 if test $test_external_has_tap -eq 0; then
723                         test_failure_ "$descr" "$@" "$output"
724                 else
725                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
726                         test_failure=$(($test_failure + 1))
727                 fi
728         fi
729 }
730
731 # debugging-friendly alternatives to "test [-f|-d|-e]"
732 # The commands test the existence or non-existence of $1. $2 can be
733 # given to provide a more precise diagnosis.
734 test_path_is_file () {
735         if ! test -f "$1"
736         then
737                 echo "File $1 doesn't exist. $2"
738                 false
739         fi
740 }
741
742 test_path_is_dir () {
743         if ! test -d "$1"
744         then
745                 echo "Directory $1 doesn't exist. $2"
746                 false
747         fi
748 }
749
750 test_path_exists () {
751         if ! test -e "$1"
752         then
753                 echo "Path $1 doesn't exist. $2"
754                 false
755         fi
756 }
757
758 # Check if the directory exists and is empty as expected, barf otherwise.
759 test_dir_is_empty () {
760         test_path_is_dir "$1" &&
761         if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
762         then
763                 echo "Directory '$1' is not empty, it contains:"
764                 ls -la "$1"
765                 return 1
766         fi
767 }
768
769 # Check if the file exists and has a size greater than zero
770 test_file_not_empty () {
771         if ! test -s "$1"
772         then
773                 echo "'$1' is not a non-empty file."
774                 false
775         fi
776 }
777
778 test_path_is_missing () {
779         if test -e "$1"
780         then
781                 echo "Path exists:"
782                 ls -ld "$1"
783                 if test $# -ge 1
784                 then
785                         echo "$*"
786                 fi
787                 false
788         fi
789 }
790
791 # test_line_count checks that a file has the number of lines it
792 # ought to. For example:
793 #
794 #       test_expect_success 'produce exactly one line of output' '
795 #               do something >output &&
796 #               test_line_count = 1 output
797 #       '
798 #
799 # is like "test $(wc -l <output) = 1" except that it passes the
800 # output through when the number of lines is wrong.
801
802 test_line_count () {
803         if test $# != 3
804         then
805                 BUG "not 3 parameters to test_line_count"
806         elif ! test $(wc -l <"$3") "$1" "$2"
807         then
808                 echo "test_line_count: line count for $3 !$1 $2"
809                 cat "$3"
810                 return 1
811         fi
812 }
813
814 test_file_size () {
815         test-tool path-utils file-size "$1"
816 }
817
818 # Returns success if a comma separated string of keywords ($1) contains a
819 # given keyword ($2).
820 # Examples:
821 # `list_contains "foo,bar" bar` returns 0
822 # `list_contains "foo" bar` returns 1
823
824 list_contains () {
825         case ",$1," in
826         *,$2,*)
827                 return 0
828                 ;;
829         esac
830         return 1
831 }
832
833 # Returns success if the arguments indicate that a command should be
834 # accepted by test_must_fail(). If the command is run with env, the env
835 # and its corresponding variable settings will be stripped before we
836 # test the command being run.
837 test_must_fail_acceptable () {
838         if test "$1" = "env"
839         then
840                 shift
841                 while test $# -gt 0
842                 do
843                         case "$1" in
844                         *?=*)
845                                 shift
846                                 ;;
847                         *)
848                                 break
849                                 ;;
850                         esac
851                 done
852         fi
853
854         case "$1" in
855         git|__git*|test-tool|test_terminal)
856                 return 0
857                 ;;
858         *)
859                 return 1
860                 ;;
861         esac
862 }
863
864 # This is not among top-level (test_expect_success | test_expect_failure)
865 # but is a prefix that can be used in the test script, like:
866 #
867 #       test_expect_success 'complain and die' '
868 #           do something &&
869 #           do something else &&
870 #           test_must_fail git checkout ../outerspace
871 #       '
872 #
873 # Writing this as "! git checkout ../outerspace" is wrong, because
874 # the failure could be due to a segv.  We want a controlled failure.
875 #
876 # Accepts the following options:
877 #
878 #   ok=<signal-name>[,<...>]:
879 #     Don't treat an exit caused by the given signal as error.
880 #     Multiple signals can be specified as a comma separated list.
881 #     Currently recognized signal names are: sigpipe, success.
882 #     (Don't use 'success', use 'test_might_fail' instead.)
883 #
884 # Do not use this to run anything but "git" and other specific testable
885 # commands (see test_must_fail_acceptable()).  We are not in the
886 # business of vetting system supplied commands -- in other words, this
887 # is wrong:
888 #
889 #    test_must_fail grep pattern output
890 #
891 # Instead use '!':
892 #
893 #    ! grep pattern output
894
895 test_must_fail () {
896         case "$1" in
897         ok=*)
898                 _test_ok=${1#ok=}
899                 shift
900                 ;;
901         *)
902                 _test_ok=
903                 ;;
904         esac
905         if ! test_must_fail_acceptable "$@"
906         then
907                 echo >&7 "test_must_fail: only 'git' is allowed: $*"
908                 return 1
909         fi
910         "$@" 2>&7
911         exit_code=$?
912         if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
913         then
914                 echo >&4 "test_must_fail: command succeeded: $*"
915                 return 1
916         elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
917         then
918                 return 0
919         elif test $exit_code -gt 129 && test $exit_code -le 192
920         then
921                 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
922                 return 1
923         elif test $exit_code -eq 127
924         then
925                 echo >&4 "test_must_fail: command not found: $*"
926                 return 1
927         elif test $exit_code -eq 126
928         then
929                 echo >&4 "test_must_fail: valgrind error: $*"
930                 return 1
931         fi
932         return 0
933 } 7>&2 2>&4
934
935 # Similar to test_must_fail, but tolerates success, too.  This is
936 # meant to be used in contexts like:
937 #
938 #       test_expect_success 'some command works without configuration' '
939 #               test_might_fail git config --unset all.configuration &&
940 #               do something
941 #       '
942 #
943 # Writing "git config --unset all.configuration || :" would be wrong,
944 # because we want to notice if it fails due to segv.
945 #
946 # Accepts the same options as test_must_fail.
947
948 test_might_fail () {
949         test_must_fail ok=success "$@" 2>&7
950 } 7>&2 2>&4
951
952 # Similar to test_must_fail and test_might_fail, but check that a
953 # given command exited with a given exit code. Meant to be used as:
954 #
955 #       test_expect_success 'Merge with d/f conflicts' '
956 #               test_expect_code 1 git merge "merge msg" B master
957 #       '
958
959 test_expect_code () {
960         want_code=$1
961         shift
962         "$@" 2>&7
963         exit_code=$?
964         if test $exit_code = $want_code
965         then
966                 return 0
967         fi
968
969         echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
970         return 1
971 } 7>&2 2>&4
972
973 # test_cmp is a helper function to compare actual and expected output.
974 # You can use it like:
975 #
976 #       test_expect_success 'foo works' '
977 #               echo expected >expected &&
978 #               foo >actual &&
979 #               test_cmp expected actual
980 #       '
981 #
982 # This could be written as either "cmp" or "diff -u", but:
983 # - cmp's output is not nearly as easy to read as diff -u
984 # - not all diff versions understand "-u"
985
986 test_cmp () {
987         eval "$GIT_TEST_CMP" '"$@"'
988 }
989
990 # Check that the given config key has the expected value.
991 #
992 #    test_cmp_config [-C <dir>] <expected-value>
993 #                    [<git-config-options>...] <config-key>
994 #
995 # for example to check that the value of core.bar is foo
996 #
997 #    test_cmp_config foo core.bar
998 #
999 test_cmp_config () {
1000         local GD &&
1001         if test "$1" = "-C"
1002         then
1003                 shift &&
1004                 GD="-C $1" &&
1005                 shift
1006         fi &&
1007         printf "%s\n" "$1" >expect.config &&
1008         shift &&
1009         git $GD config "$@" >actual.config &&
1010         test_cmp expect.config actual.config
1011 }
1012
1013 # test_cmp_bin - helper to compare binary files
1014
1015 test_cmp_bin () {
1016         cmp "$@"
1017 }
1018
1019 # Wrapper for test_cmp which used to be used for
1020 # GIT_TEST_GETTEXT_POISON=false. Only here as a shim for other
1021 # in-flight changes. Should not be used and will be removed soon.
1022 test_i18ncmp () {
1023         test_cmp "$@"
1024 }
1025
1026 # Wrapper for grep which used to be used for
1027 # GIT_TEST_GETTEXT_POISON=false. Only here as a shim for other
1028 # in-flight changes. Should not be used and will be removed soon.
1029 test_i18ngrep () {
1030         eval "last_arg=\${$#}"
1031
1032         test -f "$last_arg" ||
1033         BUG "test_i18ngrep requires a file to read as the last parameter"
1034
1035         if test $# -lt 2 ||
1036            { test "x!" = "x$1" && test $# -lt 3 ; }
1037         then
1038                 BUG "too few parameters to test_i18ngrep"
1039         fi
1040
1041         if test "x!" = "x$1"
1042         then
1043                 shift
1044                 ! grep "$@" && return 0
1045
1046                 echo >&4 "error: '! grep $@' did find a match in:"
1047         else
1048                 grep "$@" && return 0
1049
1050                 echo >&4 "error: 'grep $@' didn't find a match in:"
1051         fi
1052
1053         if test -s "$last_arg"
1054         then
1055                 cat >&4 "$last_arg"
1056         else
1057                 echo >&4 "<File '$last_arg' is empty>"
1058         fi
1059
1060         return 1
1061 }
1062
1063 # Call any command "$@" but be more verbose about its
1064 # failure. This is handy for commands like "test" which do
1065 # not output anything when they fail.
1066 verbose () {
1067         "$@" && return 0
1068         echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
1069         return 1
1070 }
1071
1072 # Check if the file expected to be empty is indeed empty, and barfs
1073 # otherwise.
1074
1075 test_must_be_empty () {
1076         test_path_is_file "$1" &&
1077         if test -s "$1"
1078         then
1079                 echo "'$1' is not empty, it contains:"
1080                 cat "$1"
1081                 return 1
1082         fi
1083 }
1084
1085 # Tests that its two parameters refer to the same revision, or if '!' is
1086 # provided first, that its other two parameters refer to different
1087 # revisions.
1088 test_cmp_rev () {
1089         local op='=' wrong_result=different
1090
1091         if test $# -ge 1 && test "x$1" = 'x!'
1092         then
1093             op='!='
1094             wrong_result='the same'
1095             shift
1096         fi
1097         if test $# != 2
1098         then
1099                 error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
1100         else
1101                 local r1 r2
1102                 r1=$(git rev-parse --verify "$1") &&
1103                 r2=$(git rev-parse --verify "$2") || return 1
1104
1105                 if ! test "$r1" "$op" "$r2"
1106                 then
1107                         cat >&4 <<-EOF
1108                         error: two revisions point to $wrong_result objects:
1109                           '$1': $r1
1110                           '$2': $r2
1111                         EOF
1112                         return 1
1113                 fi
1114         fi
1115 }
1116
1117 # Compare paths respecting core.ignoreCase
1118 test_cmp_fspath () {
1119         if test "x$1" = "x$2"
1120         then
1121                 return 0
1122         fi
1123
1124         if test true != "$(git config --get --type=bool core.ignorecase)"
1125         then
1126                 return 1
1127         fi
1128
1129         test "x$(echo "$1" | tr A-Z a-z)" =  "x$(echo "$2" | tr A-Z a-z)"
1130 }
1131
1132 # Print a sequence of integers in increasing order, either with
1133 # two arguments (start and end):
1134 #
1135 #     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
1136 #
1137 # or with one argument (end), in which case it starts counting
1138 # from 1.
1139
1140 test_seq () {
1141         case $# in
1142         1)      set 1 "$@" ;;
1143         2)      ;;
1144         *)      BUG "not 1 or 2 parameters to test_seq" ;;
1145         esac
1146         test_seq_counter__=$1
1147         while test "$test_seq_counter__" -le "$2"
1148         do
1149                 echo "$test_seq_counter__"
1150                 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
1151         done
1152 }
1153
1154 # This function can be used to schedule some commands to be run
1155 # unconditionally at the end of the test to restore sanity:
1156 #
1157 #       test_expect_success 'test core.capslock' '
1158 #               git config core.capslock true &&
1159 #               test_when_finished "git config --unset core.capslock" &&
1160 #               hello world
1161 #       '
1162 #
1163 # That would be roughly equivalent to
1164 #
1165 #       test_expect_success 'test core.capslock' '
1166 #               git config core.capslock true &&
1167 #               hello world
1168 #               git config --unset core.capslock
1169 #       '
1170 #
1171 # except that the greeting and config --unset must both succeed for
1172 # the test to pass.
1173 #
1174 # Note that under --immediate mode, no clean-up is done to help diagnose
1175 # what went wrong.
1176
1177 test_when_finished () {
1178         # We cannot detect when we are in a subshell in general, but by
1179         # doing so on Bash is better than nothing (the test will
1180         # silently pass on other shells).
1181         test "${BASH_SUBSHELL-0}" = 0 ||
1182         BUG "test_when_finished does nothing in a subshell"
1183         test_cleanup="{ $*
1184                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1185 }
1186
1187 # This function can be used to schedule some commands to be run
1188 # unconditionally at the end of the test script, e.g. to stop a daemon:
1189 #
1190 #       test_expect_success 'test git daemon' '
1191 #               git daemon &
1192 #               daemon_pid=$! &&
1193 #               test_atexit 'kill $daemon_pid' &&
1194 #               hello world
1195 #       '
1196 #
1197 # The commands will be executed before the trash directory is removed,
1198 # i.e. the atexit commands will still be able to access any pidfiles or
1199 # socket files.
1200 #
1201 # Note that these commands will be run even when a test script run
1202 # with '--immediate' fails.  Be careful with your atexit commands to
1203 # minimize any changes to the failed state.
1204
1205 test_atexit () {
1206         # We cannot detect when we are in a subshell in general, but by
1207         # doing so on Bash is better than nothing (the test will
1208         # silently pass on other shells).
1209         test "${BASH_SUBSHELL-0}" = 0 ||
1210         error "bug in test script: test_atexit does nothing in a subshell"
1211         test_atexit_cleanup="{ $*
1212                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
1213 }
1214
1215 # Most tests can use the created repository, but some may need to create more.
1216 # Usage: test_create_repo <directory>
1217 test_create_repo () {
1218         test "$#" = 1 ||
1219         BUG "not 1 parameter to test-create-repo"
1220         repo="$1"
1221         mkdir -p "$repo"
1222         (
1223                 cd "$repo" || error "Cannot setup test environment"
1224                 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" -c \
1225                         init.defaultBranch="${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME-master}" \
1226                         init \
1227                         "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
1228                 error "cannot run git init -- have you built things yet?"
1229                 mv .git/hooks .git/hooks-disabled
1230         ) || exit
1231 }
1232
1233 # This function helps on symlink challenged file systems when it is not
1234 # important that the file system entry is a symbolic link.
1235 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1236 # symbolic link entry y to the index.
1237
1238 test_ln_s_add () {
1239         if test_have_prereq SYMLINKS
1240         then
1241                 ln -s "$1" "$2" &&
1242                 git update-index --add "$2"
1243         else
1244                 printf '%s' "$1" >"$2" &&
1245                 ln_s_obj=$(git hash-object -w "$2") &&
1246                 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1247                 # pick up stat info from the file
1248                 git update-index "$2"
1249         fi
1250 }
1251
1252 # This function writes out its parameters, one per line
1253 test_write_lines () {
1254         printf "%s\n" "$@"
1255 }
1256
1257 perl () {
1258         command "$PERL_PATH" "$@" 2>&7
1259 } 7>&2 2>&4
1260
1261 # Given the name of an environment variable with a bool value, normalize
1262 # its value to a 0 (true) or 1 (false or empty string) return code.
1263 #
1264 #   test_bool_env GIT_TEST_HTTPD <default-value>
1265 #
1266 # Return with code corresponding to the given default value if the variable
1267 # is unset.
1268 # Abort the test script if either the value of the variable or the default
1269 # are not valid bool values.
1270
1271 test_bool_env () {
1272         if test $# != 2
1273         then
1274                 BUG "test_bool_env requires two parameters (variable name and default value)"
1275         fi
1276
1277         git env--helper --type=bool --default="$2" --exit-code "$1"
1278         ret=$?
1279         case $ret in
1280         0|1)    # unset or valid bool value
1281                 ;;
1282         *)      # invalid bool value or something unexpected
1283                 error >&7 "test_bool_env requires bool values both for \$$1 and for the default fallback"
1284                 ;;
1285         esac
1286         return $ret
1287 }
1288
1289 # Exit the test suite, either by skipping all remaining tests or by
1290 # exiting with an error. If our prerequisite variable $1 falls back
1291 # on a default assume we were opportunistically trying to set up some
1292 # tests and we skip. If it is explicitly "true", then we report a failure.
1293 #
1294 # The error/skip message should be given by $2.
1295 #
1296 test_skip_or_die () {
1297         if ! test_bool_env "$1" false
1298         then
1299                 skip_all=$2
1300                 test_done
1301         fi
1302         error "$2"
1303 }
1304
1305 # The following mingw_* functions obey POSIX shell syntax, but are actually
1306 # bash scripts, and are meant to be used only with bash on Windows.
1307
1308 # A test_cmp function that treats LF and CRLF equal and avoids to fork
1309 # diff when possible.
1310 mingw_test_cmp () {
1311         # Read text into shell variables and compare them. If the results
1312         # are different, use regular diff to report the difference.
1313         local test_cmp_a= test_cmp_b=
1314
1315         # When text came from stdin (one argument is '-') we must feed it
1316         # to diff.
1317         local stdin_for_diff=
1318
1319         # Since it is difficult to detect the difference between an
1320         # empty input file and a failure to read the files, we go straight
1321         # to diff if one of the inputs is empty.
1322         if test -s "$1" && test -s "$2"
1323         then
1324                 # regular case: both files non-empty
1325                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1326                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1327         elif test -s "$1" && test "$2" = -
1328         then
1329                 # read 2nd file from stdin
1330                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1331                 mingw_read_file_strip_cr_ test_cmp_b
1332                 stdin_for_diff='<<<"$test_cmp_b"'
1333         elif test "$1" = - && test -s "$2"
1334         then
1335                 # read 1st file from stdin
1336                 mingw_read_file_strip_cr_ test_cmp_a
1337                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1338                 stdin_for_diff='<<<"$test_cmp_a"'
1339         fi
1340         test -n "$test_cmp_a" &&
1341         test -n "$test_cmp_b" &&
1342         test "$test_cmp_a" = "$test_cmp_b" ||
1343         eval "diff -u \"\$@\" $stdin_for_diff"
1344 }
1345
1346 # $1 is the name of the shell variable to fill in
1347 mingw_read_file_strip_cr_ () {
1348         # Read line-wise using LF as the line separator
1349         # and use IFS to strip CR.
1350         local line
1351         while :
1352         do
1353                 if IFS=$'\r' read -r -d $'\n' line
1354                 then
1355                         # good
1356                         line=$line$'\n'
1357                 else
1358                         # we get here at EOF, but also if the last line
1359                         # was not terminated by LF; in the latter case,
1360                         # some text was read
1361                         if test -z "$line"
1362                         then
1363                                 # EOF, really
1364                                 break
1365                         fi
1366                 fi
1367                 eval "$1=\$$1\$line"
1368         done
1369 }
1370
1371 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1372 # it also works for shell functions (though those functions cannot impact
1373 # the environment outside of the test_env invocation).
1374 test_env () {
1375         (
1376                 while test $# -gt 0
1377                 do
1378                         case "$1" in
1379                         *=*)
1380                                 eval "${1%%=*}=\${1#*=}"
1381                                 eval "export ${1%%=*}"
1382                                 shift
1383                                 ;;
1384                         *)
1385                                 "$@" 2>&7
1386                                 exit
1387                                 ;;
1388                         esac
1389                 done
1390         )
1391 } 7>&2 2>&4
1392
1393 # Returns true if the numeric exit code in "$2" represents the expected signal
1394 # in "$1". Signals should be given numerically.
1395 test_match_signal () {
1396         if test "$2" = "$((128 + $1))"
1397         then
1398                 # POSIX
1399                 return 0
1400         elif test "$2" = "$((256 + $1))"
1401         then
1402                 # ksh
1403                 return 0
1404         fi
1405         return 1
1406 }
1407
1408 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1409 test_copy_bytes () {
1410         perl -e '
1411                 my $len = $ARGV[1];
1412                 while ($len > 0) {
1413                         my $s;
1414                         my $nread = sysread(STDIN, $s, $len);
1415                         die "cannot read: $!" unless defined($nread);
1416                         last unless $nread;
1417                         print $s;
1418                         $len -= $nread;
1419                 }
1420         ' - "$1"
1421 }
1422
1423 # run "$@" inside a non-git directory
1424 nongit () {
1425         test -d non-repo ||
1426         mkdir non-repo ||
1427         return 1
1428
1429         (
1430                 GIT_CEILING_DIRECTORIES=$(pwd) &&
1431                 export GIT_CEILING_DIRECTORIES &&
1432                 cd non-repo &&
1433                 "$@" 2>&7
1434         )
1435 } 7>&2 2>&4
1436
1437 # convert function arguments or stdin (if not arguments given) to pktline
1438 # representation. If multiple arguments are given, they are separated by
1439 # whitespace and put in a single packet. Note that data containing NULs must be
1440 # given on stdin, and that empty input becomes an empty packet, not a flush
1441 # packet (for that you can just print 0000 yourself).
1442 packetize () {
1443         if test $# -gt 0
1444         then
1445                 packet="$*"
1446                 printf '%04x%s' "$((4 + ${#packet}))" "$packet"
1447         else
1448                 perl -e '
1449                         my $packet = do { local $/; <STDIN> };
1450                         printf "%04x%s", 4 + length($packet), $packet;
1451                 '
1452         fi
1453 }
1454
1455 # Parse the input as a series of pktlines, writing the result to stdout.
1456 # Sideband markers are removed automatically, and the output is routed to
1457 # stderr if appropriate.
1458 #
1459 # NUL bytes are converted to "\\0" for ease of parsing with text tools.
1460 depacketize () {
1461         perl -e '
1462                 while (read(STDIN, $len, 4) == 4) {
1463                         if ($len eq "0000") {
1464                                 print "FLUSH\n";
1465                         } else {
1466                                 read(STDIN, $buf, hex($len) - 4);
1467                                 $buf =~ s/\0/\\0/g;
1468                                 if ($buf =~ s/^[\x2\x3]//) {
1469                                         print STDERR $buf;
1470                                 } else {
1471                                         $buf =~ s/^\x1//;
1472                                         print $buf;
1473                                 }
1474                         }
1475                 }
1476         '
1477 }
1478
1479 # Converts base-16 data into base-8. The output is given as a sequence of
1480 # escaped octals, suitable for consumption by 'printf'.
1481 hex2oct () {
1482         perl -ne 'printf "\\%03o", hex for /../g'
1483 }
1484
1485 # Set the hash algorithm in use to $1.  Only useful when testing the testsuite.
1486 test_set_hash () {
1487         test_hash_algo="$1"
1488 }
1489
1490 # Detect the hash algorithm in use.
1491 test_detect_hash () {
1492         test_hash_algo="${GIT_TEST_DEFAULT_HASH:-sha1}"
1493 }
1494
1495 # Load common hash metadata and common placeholder object IDs for use with
1496 # test_oid.
1497 test_oid_init () {
1498         test -n "$test_hash_algo" || test_detect_hash &&
1499         test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1500         test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1501 }
1502
1503 # Load key-value pairs from stdin suitable for use with test_oid.  Blank lines
1504 # and lines starting with "#" are ignored.  Keys must be shell identifier
1505 # characters.
1506 #
1507 # Examples:
1508 # rawsz sha1:20
1509 # rawsz sha256:32
1510 test_oid_cache () {
1511         local tag rest k v &&
1512
1513         { test -n "$test_hash_algo" || test_detect_hash; } &&
1514         while read tag rest
1515         do
1516                 case $tag in
1517                 \#*)
1518                         continue;;
1519                 ?*)
1520                         # non-empty
1521                         ;;
1522                 *)
1523                         # blank line
1524                         continue;;
1525                 esac &&
1526
1527                 k="${rest%:*}" &&
1528                 v="${rest#*:}" &&
1529
1530                 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1531                 then
1532                         BUG 'bad hash algorithm'
1533                 fi &&
1534                 eval "test_oid_${k}_$tag=\"\$v\""
1535         done
1536 }
1537
1538 # Look up a per-hash value based on a key ($1).  The value must have been loaded
1539 # by test_oid_init or test_oid_cache.
1540 test_oid () {
1541         local algo="${test_hash_algo}" &&
1542
1543         case "$1" in
1544         --hash=*)
1545                 algo="${1#--hash=}" &&
1546                 shift;;
1547         *)
1548                 ;;
1549         esac &&
1550
1551         local var="test_oid_${algo}_$1" &&
1552
1553         # If the variable is unset, we must be missing an entry for this
1554         # key-hash pair, so exit with an error.
1555         if eval "test -z \"\${$var+set}\""
1556         then
1557                 BUG "undefined key '$1'"
1558         fi &&
1559         eval "printf '%s' \"\${$var}\""
1560 }
1561
1562 # Insert a slash into an object ID so it can be used to reference a location
1563 # under ".git/objects".  For example, "deadbeef..." becomes "de/adbeef..".
1564 test_oid_to_path () {
1565         local basename=${1#??}
1566         echo "${1%$basename}/$basename"
1567 }
1568
1569 # Choose a port number based on the test script's number and store it in
1570 # the given variable name, unless that variable already contains a number.
1571 test_set_port () {
1572         local var=$1 port
1573
1574         if test $# -ne 1 || test -z "$var"
1575         then
1576                 BUG "test_set_port requires a variable name"
1577         fi
1578
1579         eval port=\$$var
1580         case "$port" in
1581         "")
1582                 # No port is set in the given env var, use the test
1583                 # number as port number instead.
1584                 # Remove not only the leading 't', but all leading zeros
1585                 # as well, so the arithmetic below won't (mis)interpret
1586                 # a test number like '0123' as an octal value.
1587                 port=${this_test#${this_test%%[1-9]*}}
1588                 if test "${port:-0}" -lt 1024
1589                 then
1590                         # root-only port, use a larger one instead.
1591                         port=$(($port + 10000))
1592                 fi
1593                 ;;
1594         *[!0-9]*|0*)
1595                 error >&7 "invalid port number: $port"
1596                 ;;
1597         *)
1598                 # The user has specified the port.
1599                 ;;
1600         esac
1601
1602         # Make sure that parallel '--stress' test jobs get different
1603         # ports.
1604         port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1605         eval $var=$port
1606 }
1607
1608 # Compare a file containing rev-list bitmap traversal output to its non-bitmap
1609 # counterpart. You can't just use test_cmp for this, because the two produce
1610 # subtly different output:
1611 #
1612 #   - regular output is in traversal order, whereas bitmap is split by type,
1613 #     with non-packed objects at the end
1614 #
1615 #   - regular output has a space and the pathname appended to non-commit
1616 #     objects; bitmap output omits this
1617 #
1618 # This function normalizes and compares the two. The second file should
1619 # always be the bitmap output.
1620 test_bitmap_traversal () {
1621         if test "$1" = "--no-confirm-bitmaps"
1622         then
1623                 shift
1624         elif cmp "$1" "$2"
1625         then
1626                 echo >&2 "identical raw outputs; are you sure bitmaps were used?"
1627                 return 1
1628         fi &&
1629         cut -d' ' -f1 "$1" | sort >"$1.normalized" &&
1630         sort "$2" >"$2.normalized" &&
1631         test_cmp "$1.normalized" "$2.normalized" &&
1632         rm -f "$1.normalized" "$2.normalized"
1633 }
1634
1635 # Tests for the hidden file attribute on Windows
1636 test_path_is_hidden () {
1637         test_have_prereq MINGW ||
1638         BUG "test_path_is_hidden can only be used on Windows"
1639
1640         # Use the output of `attrib`, ignore the absolute path
1641         case "$("$SYSTEMROOT"/system32/attrib "$1")" in *H*?:*) return 0;; esac
1642         return 1
1643 }
1644
1645 # Check that the given command was invoked as part of the
1646 # trace2-format trace on stdin.
1647 #
1648 #       test_subcommand [!] <command> <args>... < <trace>
1649 #
1650 # For example, to look for an invocation of "git upload-pack
1651 # /path/to/repo"
1652 #
1653 #       GIT_TRACE2_EVENT=event.log git fetch ... &&
1654 #       test_subcommand git upload-pack "$PATH" <event.log
1655 #
1656 # If the first parameter passed is !, this instead checks that
1657 # the given command was not called.
1658 #
1659 test_subcommand () {
1660         local negate=
1661         if test "$1" = "!"
1662         then
1663                 negate=t
1664                 shift
1665         fi
1666
1667         local expr=$(printf '"%s",' "$@")
1668         expr="${expr%,}"
1669
1670         if test -n "$negate"
1671         then
1672                 ! grep "\[$expr\]"
1673         else
1674                 grep "\[$expr\]"
1675         fi
1676 }
1677
1678 # Check that the given command was invoked as part of the
1679 # trace2-format trace on stdin.
1680 #
1681 #       test_region [!] <category> <label> git <command> <args>...
1682 #
1683 # For example, to look for trace2_region_enter("index", "do_read_index", repo)
1684 # in an invocation of "git checkout HEAD~1", run
1685 #
1686 #       GIT_TRACE2_EVENT="$(pwd)/trace.txt" GIT_TRACE2_EVENT_NESTING=10 \
1687 #               git checkout HEAD~1 &&
1688 #       test_region index do_read_index <trace.txt
1689 #
1690 # If the first parameter passed is !, this instead checks that
1691 # the given region was not entered.
1692 #
1693 test_region () {
1694         local expect_exit=0
1695         if test "$1" = "!"
1696         then
1697                 expect_exit=1
1698                 shift
1699         fi
1700
1701         grep -e '"region_enter".*"category":"'"$1"'","label":"'"$2"\" "$3"
1702         exitcode=$?
1703
1704         if test $exitcode != $expect_exit
1705         then
1706                 return 1
1707         fi
1708
1709         grep -e '"region_leave".*"category":"'"$1"'","label":"'"$2"\" "$3"
1710         exitcode=$?
1711
1712         if test $exitcode != $expect_exit
1713         then
1714                 return 1
1715         fi
1716
1717         return 0
1718 }